
/* Generated by Interface Builder */

#import "Tools.h"
#import "Postit.h"
#import "scan.h"
#import "tquote.h"
#include <sys/types.h>
#include <sys/param.h>
#include <stdio.h>
#include <string.h>
#import <appkit/Cell.h>
#import <appkit/Matrix.h>
#import <appkit/Menu.h>
#import <appkit/OpenPanel.h>
#import <appkit/SavePanel.h>
#import <objc/Storage.h>
#import <stdlib.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <sys/resource.h>
#include "error.h"

void getkids();

@implementation Tools

- saveMenus:sender
{
    return self;
}

- appDidInit:sender
{
    curTag = 1;
    signal(SIGCHLD, getkids);
    commandStorage = [Storage newCount:50 elementSize:sizeof(char *)
	description:"char *"];
    [self loadMenus:self];
    [NXApp setDelegate:self];    /// But I am the bombadeer...
    return self;
}
- terminate:sender
{
   [postit autoSaveAll:sender];
   return [super terminate:sender];
}
-(int)openFile:(const char *)path ok:(int *)flag
{
   if ([postit loadWindowList:path])*flag=1;
   else *flag=0;
   return !(*flag);   // c'est la vie....c'est RPN
}
- loadMenus:sender
{
    char aPath[MAXPATHLEN+1];
    id mainMenu;

    strcpy(aPath, getenv("HOME"));
    strcat(aPath, "/.toolsrc");

    /* Set up scanner for our configuration */

    TQcEscape = '\\';		/* the "escape" character or NUL	*/
    TQpcNullEffect = "\n";	/* escaped, these are *empty* 		*/
    TQpcTerminate = "\n";	/* can not be quoted			*/
    TQpcIFS = " \t\n,():";	/* terminates string if not quoted	*/
    TQpcQuote = "\"\'";		/* quote character(s)			*/

    if (0 != ReScan(aPath)) {
	/* XXX Dialog panel here */
	fprintf(stderr, "Couldn't open %s\n", aPath);
    }
    mainMenu = [NXApp mainMenu];
    /* Parses config file and creates menus */
    [self addMenusAt:mainMenu];

    [[mainMenu addItem:"Hide" action:@selector(hide:) keyEquivalent:'h']
	setTarget:NXApp];

    [[mainMenu addItem:"Quit" action:@selector(terminate:) keyEquivalent:'q']
	setTarget:NXApp];

    [mainMenu display];
    return self;
}

- addMenusAt:sender
{
	TOKEN Token;
	SEL RunCommand;
	id newEntry;
	id newMenu;
	int newTag;
	char *newCommand,newMenuEquiv;

	RunCommand = @selector(runCommand:);
	while (T_EOF != (Token = GetToken())) {
		if ((T_STRING != Token) && (T_END != Token)) {
			ShowError("Missing label");
			return self;
		}
		if (T_END == Token) {
			/* End recursion on empty list */
			return self;
		}
		if (0 == strcmp(VLValue.pc, "autostart")) {
			if (T_STRING == (Token = GetToken())) {
				system(VLValue.pc);
				continue;
			} else {
				ShowError("Syntax error:  Expected a string");
				/* Token error recovery, guess a ":" */
				Token = GetToken();
			}
		}
		if (0 == strcmp(VLValue.pc, "postitdir")) {
			if (T_STRING == (Token = GetToken())) {
				[[OpenPanel new] setDirectory:VLValue.pc];
				[[SavePanel new] setDirectory:VLValue.pc];
				continue;
			} else {
				ShowError("Syntax error:  Expected a string");
				/* Token error recovery, guess a ":" */
				Token = GetToken();
			}
		}

		if (VLValue.pc[0]=='+') {
		    VLValue.pc++;		    /// skip over MenuEquiv delimiter
		    newMenuEquiv=VLValue.pc[0];     /// first char will be menu Equiv
		    VLValue.pc++;
		} else newMenuEquiv='0';
		newEntry = [sender addItem:VLValue.pc action:RunCommand
			keyEquivalent:newMenuEquiv];
			
		[newEntry setTarget:self];

		if (T_BIND != (Token = GetToken())) {
			ShowError("Missing :");
		}

		switch (Token = GetToken()) {

		/* Action */
		case T_STRING:
			newTag = [self getTag];
			[newEntry setTag:newTag];
			newCommand = malloc(strlen(VLValue.pc)+3);
			strcpy(newCommand, VLValue.pc);
			free(VLValue.pc);
			strcat(newCommand, " &");
			[commandStorage insert:&newCommand at:newTag];

			switch (Token = GetToken()) {

			case T_EOF:
				ShowError("Unexpected End of File");
				return self;
			case T_COMMA:
				continue;
			case T_END:
				return self;
			default:
				ShowError("Syntax Error");
				return self;
			}

		case T_START:
			newMenu = [Menu newTitle:[newEntry title]];
			[sender setSubmenu:newMenu forItem:newEntry];

			[self addMenusAt:newMenu];
			[newMenu update];
			[newMenu display];

			/* make sender a submenu */
			break;

		default:
			fprintf(stderr, "Token is %d\n", Token);
			fprintf(stderr, "String is %s\n", VLValue.pc);
			ShowError("Syntax Error, expected action (string) or list \"()\"");
			break;
		}
    }
    return self;
}

- runCommand:sender
{
	id curCell;
	int tagValue;

	curCell = [sender selectedCell];
	tagValue = [curCell tag];
	system(*(char **)[commandStorage elementAt:tagValue]);
	return self;
}

- (int) getTag
{
	return curTag++;
}

void
getkids()
{
	union wait status;

	wait3(&status, WNOHANG, 0);
}

- setPostit:anObject
{ 
   postit = anObject;
   return self;
}
@end
